<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>
      <v-row
        v-for="(p, index) in resources"
        :key="index"
        dense
      >
        <v-col cols="12">
          <v-row align="center" dense>
            <v-col cols="1">
              <v-img
                max-width="30px"
                contain
                :src="p.logo"
              ></v-img>
            </v-col>
            <v-col cols="3" >
              <v-select
                :items="images"
                label="VM name"
                item-text="label"
                item-value="value"
                :loading="loading"
                :disabled="loading"
                return-object
                v-model="p.image"
                XXv-on:change="imageChanged(index, p.image)"
                :rules="imageRules"
                required
                :error-messages="p.errorMessages"
              ></v-select>
            </v-col>
            <v-col cols="2" >
              <v-text-field
                label="Platform"
                hint="platform hint"
                v-model="p.platform"
              ></v-text-field>
            </v-col>
            <v-col cols="5">
              <v-select
                :items="flavours"
                label="VM flavour(s)"
                item-text="flavour"
                :loading="loading"
                :disabled="loading"
                return-object
                v-model="p.flavours"
                multiple
                :rules="flavourRules"
                required
              >
                <template slot="item" slot-scope="data">
                    {{ data.item.flavour }}
                </template>
                <template slot="selection" slot-scope="data">
                    <v-chip label small>{{ data.item.flavour }}</v-chip>
                </template>
              </v-select>
            </v-col>
            <v-col cols="1" align="center">
              <v-icon
                v-on:click="deleteEntry(index)"
              >mdi-delete</v-icon>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
      <v-row dense>
        <v-col cols="12">
          <v-btn
            depressed
            v-bind:class="{ 'error': errorMessages.length>0}"
            v-on:click="addEntry()"
            v-on:blur="validate()"
            :disabled="disabled"
            small
          >
          <v-icon>mdi-plus</v-icon>
          {{addButtonLabel}}
          </v-btn>
          <div
            :key="msg"
            v-for="(msg) in errorMessages"
            class="v-messages error--text"
          >{{msg}}</div>
        </v-col>
      </v-row>
   </v-container>

</template>

<script>

var keyAndValues = [
  {key: "debian", platform:"debian", vm_user:"debian", img:"https://upload.wikimedia.org/wikipedia/commons/thumb/6/66/Openlogo-debianV2.svg/1200px-Openlogo-debianV2.svg.png"},
  {key: "centos", platform:"centos", vm_user:"centos", img:"https://upload.wikimedia.org/wikipedia/commons/thumb/6/63/CentOS_color_logo.svg/256px-CentOS_color_logo.svg.png"},
  {key: "windows", platform:"windows", vm_user:"asdf", img:"https://upload.wikimedia.org/wikipedia/commons/0/0a/Unofficial_Windows_logo_variant_-_2002%E2%80%932012_%28Multicolored%29.svg"},
  {key: "ubuntu", platform:"ubuntu", vm_user:"ubuntu", img:"https://upload.wikimedia.org/wikipedia/commons/thumb/a/ab/Logo-ubuntu_cof-orange-hex.svg/285px-Logo-ubuntu_cof-orange-hex.svg.png"},
  {key: "linux", platform:"linux", vm_user:"root", img:"https://upload.wikimedia.org/wikipedia/commons/a/af/Tux.png"},
  {key: "", platform:"", vm_user:"", img:"https://upload.wikimedia.org/wikipedia/commons/d/d2/Question_mark.svg"}
];

export default {

  name: 'BenchmarkedResourcesEditor',

  props: {
    addButtonLabel: {
      type: String,
      default: "Add resource type"
    },
    resources: {
      type: Array,
      default: function() {return []}
    },
    images: {
      type: Array,
      default: function() {return []}
    },
    flavours: {
      type: Array,
      default: function() {return []}
    },
    loading: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },

  data: () => ({

    errorMessages: [],

    imageRules: [
        v => !!v.label || 'A provider is required'
      ],
    flavourRules: [
        v => (v && v.length>0) || 'At least one flavour is required'
      ]
  }),

  watch: {
    resources: {
      deep: true,
      handler: function() {
        this.validate();
        this.setLogos();
      }
    }

  },

  mounted () {
  },

  methods: {

    validate: function() {
      this.errorMessages.splice(0, this.errorMessages.length)
      if(this.resources.length==0) {
        this.errorMessages.push("At least one resource type is required");
      }

      var images = {};
      for(var j in this.resources) {
        var k = this.resources[j].image.label;
        if(images[k]==null)
          images[k]=0;
        images[k]++;
      }

      for(var i in this.resources) {
        var messages = [];
        var entry = this.resources[i];

        // check for duplicate keys
        if(images[entry.image.label]>1)
          messages.push("Duplicate entry: '"+entry.image.label+"'");

        entry.error = messages.length>0;
        entry.errorMessages = messages;

      }

    },

    deleteEntry: function(index) {
      this.resources.splice(index, 1);
    },

    addEntry: function() {
      this.resources.push({key:"", value:"", image:{label:""}, flavours:[]});
    },

    imageChanged: function(index, image) {
      var v = this.guessValues(image.name);
      if(v && v.platform) {
        this.resources[index].platform = v.platform;
      }
      if(v && v.vm_user) {
        this.resources[index].vm_user = v.vm_user;
      }
      if(v && v.img) {
        this.resources[index].logo = v.img;
      } else {
        this.resources[index].logo = "";
      }
    },

    setLogos: function() {
      for(var i in this.resources) {
        var entry = this.resources[i];
        var values = this.guessValues(entry.image.label);
        if(values) {
          entry.logo = values.img;
        }
      }
    },

    guessValues: function(imageName) {
      for(var i in keyAndValues) {
        var o = keyAndValues[i];
        if(imageName.toLowerCase().indexOf(o.key)!=-1) {
          return o;
        }
      }
      return null
    }

  }

};

</script>

<style>
</style>
